3 GIT_DIR=`git-rev-parse --git-dir` || exit $?
11 echo >&2 "usage: $(basename $0)"' [-d <branch>] | [[-f] <branch> [start-point]]
13 If no arguments, show available branches and mark current branch with a star.
14 If one argument, create a new branch <branchname> based off of current HEAD.
15 If two arguments, create a new branch <branchname> based off of <start-point>.
20 headref=$(git-symbolic-ref HEAD | sed -e 's|^refs/heads/||')
29 die "Cannot delete the branch you are on." ;;
31 die "What branch are you on anyway?" ;;
33 branch=$(cat "$GIT_DIR/refs/heads/$branch_name") &&
34 branch=$(git-rev-parse --verify "$branch^0") ||
35 die "Seriously, what branch are you talking about?"
40 mbs=$(git-merge-base -a "$branch" HEAD | tr '\012' ' ')
43 # the merge base of branch and HEAD contains branch --
44 # which means that the HEAD contains everything in the HEAD.
47 echo >&2 "The branch '$branch_name' is not a strict subset of your current HEAD.
48 If you are sure you want to delete it, run 'git branch -D $branch_name'."
54 rm -f "$GIT_DIR/refs/heads/$branch_name"
55 echo "Deleted branch $branch_name."
61 while case "$#,$1" in 0,*) break ;; *,-*) ;; *) break ;; esac
84 git-rev-parse --symbolic --all |
85 sed -ne 's|^refs/heads/||p' |
89 if test "$headref" = "$ref"
105 rev=$(git-rev-parse --verify "$head") || exit
107 git-check-ref-format "heads/$branchname" ||
108 die "we do not like '$branchname' as a branch name."
110 if [ -e "$GIT_DIR/refs/heads/$branchname" ]
112 if test '' = "$force"
114 die "$branchname already exists."
115 elif test "$branchname" = "$headref"
117 die "cannot force-update the current branch."
120 git update-ref "refs/heads/$branchname" $rev